#include "pch.h"
#include "SAMessenger.h"
#include "SAInstSDKUserSample.h"
#include "SAInstSDKUserSampleDlg.h"

SAMessenger::SAMessenger(void)
{

}

SAMessenger::~SAMessenger(void)
{

}

void SAMessenger::CollectionGroupTargetNamesFromSA(std::string c, std::string g, std::string t)
{
	CString m;
	CString coll(CA2W(c.c_str()));
	CString gp(CA2W(g.c_str()));
	CString targ(CA2W(t.c_str()));
	m.Format(_T("From SA: collection='%s', group='%s', target='%s'"), coll, gp, targ);
	::MessageBox(NULL, m, _T("SA Command Received"), MB_ICONINFORMATION | MB_SETFOREGROUND | MB_TOPMOST);

	TRACE("CollectionGroupTargetNamesFromSA, c=%s, g=%s, t=%s\n", c.c_str(), g.c_str(), t.c_str());
}

bool SAMessenger::BeginMeasureMessageFromSA()
{
	CString m;
	m.Format(_T("Begin Measurement"));
	::MessageBox(NULL, m, _T("SAInstSDK: Command Received"), MB_ICONINFORMATION | MB_SETFOREGROUND | MB_TOPMOST);

	TRACE("BeginMeasureMessageFromSA received\n");
	return true;
}
bool SAMessenger::StopMeasureMessageFromSA()
{
	CString m;
	m.Format(_T("Stop Measure"));
	::MessageBox(NULL, m, _T("SAInstSDK: Command Received"), MB_ICONINFORMATION | MB_SETFOREGROUND | MB_TOPMOST);

	TRACE("StopMeasureMessageFromSA received\n");
	return true;
}

bool SAMessenger::BatchMeasPointsFromSA(std::vector<std::string> c, std::vector<std::string> g, std::vector<std::string> t, std::vector<SAvector> nomPt)
{
	CSAInstSDKUserSampleDlg& d = *((CSAInstSDKUserSampleDlg*)theApp.m_pMainWnd);

	TRACE("BatchMeasPointsFromSA:\n");
	std::vector<SAxform> xforms; // if we don't populate this, then we just send an empty vector in SendBatchofPtstoSA, and the batch is interpretted as 3D
	// OR we can populate the xform vector, and the batch will be interpretted as 6D
	//std::vector<SAxform> xforms(nomPt.size());
	//for (INT_PTR i = 0; i < nomPt.size(); i++)
	//{
	//	SAvector rot;
	//	rot.x = 3.0;
	//	rot.y = 1.5;
	//	rot.z = (double)i*3.0;
	//	TRACE(" pt %d, c::g::t = %s::%s::%s, nomXYX = %f, %f, %f, fixedXYZ Rotation: %f, %f, %f\n", 
	//		i, c[i].c_str(), g[i].c_str(), t[i].c_str(), nomPt[i].x, nomPt[i].y, nomPt[i].z, rot.x, rot.y, rot.z);
	//	xforms[i] = d.sa.SetFromOriginAndFixedRxyzDegrees(nomPt[i], rot);
	//}
	//TRACE("\n");

	std::vector<SAvector> sigmas(nomPt.size());
	for (INT_PTR i = 0; i < nomPt.size(); i++)
	{
		sigmas[i].x = 0.001;
		sigmas[i].y = 0.002;
		sigmas[i].z= 0.003;
	}

	std::vector<std::string> notes;
	//std::vector<std::string> notes(3);
	//notes[0] = "This is a 6D point.";
	//notes[1] = "You can construct a frame from";
	//notes[2] = "its Measurement Probing Frame in SA";

	// This can be used for most instruments
	//d.sa.SendBatchofPtsToSA(nomPt, xforms, sigmas, c, g, t, 0.125, 0.125, notes);

	// or SendIJKUncertPointWithNamesArrayToSA is an option for e.g. photogrammetry inst's, 
	// where each target may come in with a unique (non-iterated) name
	std::vector<SAvector> ijks(nomPt.size());
	for (INT_PTR i = 0; i < nomPt.size(); i++)
	{
		ijks[i].x = 0.0;
		ijks[i].y = 0.0;
		ijks[i].z = -1.0;
	}
	d.sa.SendIJKUncertPointWithNamesArrayToSA(nomPt, ijks, sigmas, t, 0.125, 0.125, g[0], c[0]);
	
	return true;
}

bool SAMessenger::OpCheckCommandFromSA(std::string command)
{
	CString m;
	CString cmd(CA2W(command.c_str()));
	m.Format(_T("Command: '%s'"), cmd);
	::MessageBox(NULL, m, _T("SAInstSDK: Command Received"), MB_ICONINFORMATION | MB_SETFOREGROUND | MB_TOPMOST);

	TRACE("OpCheckCommandFromSA received, command = %s\n", command.c_str());
	return true;
}