#pragma once
#include "../resource.h"

class CDockManagerClient;

/////////////////////////////////////////////////////////////////////////////
// CDockingBtnCtrl window

class AFX_EXT_CLASS CDockingBtnCtrl : public CButton
{
// Construction
public:
	// Default constructor (required for MFC compatibility)
	CDockingBtnCtrl();
	CDockingBtnCtrl(UINT up, UINT down = 0, UINT disabled = 0, BOOL fill = FALSE);

	void SetDockManagerClient(HWND hSpatialAnalyzerMainFrame, CDockManagerClient& clientDocManager);
	BOOL ForceDockBtnClick();

	BOOL m_fill; // We want to fill the image

	BOOL IsDocked();

	//----------------------
	// LoadBitmaps
	//	UINT up: Resource ID of image to use for up, enabled
	//	UINT down: Resource ID of image to use for down, enabled
	//			if NULL, the up image is used
	//	UINT disabled: Resource ID of image to use for disabled
	//			if NULL, the up image is halftoned gray
	void LoadBitmaps(UINT up, UINT down, UINT disabled)
	{ this->up = up; this->down = down; this->disabled = disabled; } 
	void GetBitmaps(UINT &up, UINT &down, UINT &disabled)
	{ up = this->up; down = this->down; disabled = this->disabled; }

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDockingBtnCtrl)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDockingBtnCtrl();

	CRect GetUndockedRect();
	void SetUndockedRect(CRect& r);

	// Generated message map functions
protected:
	UINT up;
	UINT down;
	UINT disabled;
	UINT m_nTypeStyle;
	BOOL m_bBtnPushed;
	virtual void PreSubclassWindow();
	afx_msg BOOL OnClicked();
	//{{AFX_MSG(CDockingBtnCtrl)
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

private:
	CDockManagerClient* m_pDocManagerClient;
	HWND m_hSpatialAnalyzerMainFrame;

};

